package controllers.ext.bdy;

import models.ext.bdy.BDYHealthValueBean;
import models.ext.bdy.BDYWeightValueBean;
import models.ext.dba.bdy.DBAWeightRecordControlBean;
import models.ueat.dba.DBAControlBeanInterface;
import models.ueat.exp.EXPConditionValueBean;
import util.com.COMDef;
import util.com.COMUtility;
import controllers.ueat.com.COMRequestManager;
import controllers.ueat.exp.EXPCommonManager;
import controllers.ueat.exp.EXPManagerInterface;

public class BDYHealthManager
    extends EXPCommonManager implements EXPManagerInterface {

    @Override
    public boolean execute() {
        String requestName = getRequest().getParameter("request");
        String queryPattern = COMRequestManager.getInstance().getQueryPattern(requestName);
        switch (queryPattern) {
        case COMDef.QUERY_PTN_SELECT:
            if (!draw()) {
                return false;
            }
            break;
        case COMDef.QUERY_PTN_INSERT:
            if (!addData()) {
                return false;
            }
            break;
        case COMDef.QUERY_PTN_UPDATE:
            break;
        case COMDef.QUERY_PTN_DELETE:
            break;
        case COMDef.QUERY_PTN_NONE:
            break;
        default:
            break;
        }

        return true;
    }

    private boolean draw() {
        DBAControlBeanInterface control;
        try {
            control = DBAWeightRecordControlBean.class.newInstance();

            EXPConditionValueBean condValue = new EXPConditionValueBean();
            control.setCondParam(condValue);
            if (!control.select()) {
                return false;
            }

//            EXPStructHighChartData chData = new EXPStructHighChartData();
//            EXPHighChartValueBean hcValue = new EXPHighChartValueBean();
//            hcValue.setDispHeight(600);
//            hcValue.setDispWidth(1000);
//            chData.setHighChartValue(hcValue);
//            chData.setTargetValue((EXPUtilityExpensesValueBean)control.getResultValue());
//            String strChartData = chData.createBillChartData();
//            ((EXPUtilityExpensesValueBean)control.getResultValue()).setHighChartData(strChartData);

            setValueBean(control.getResultValue());
        }
        catch (InstantiationException e) {
            e.printStackTrace();
            return false;
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    private boolean addData() {
        DBAControlBeanInterface control;
        try {
            control = DBAWeightRecordControlBean.class.newInstance();

            BDYHealthValueBean value = new BDYHealthValueBean();

            BDYWeightValueBean wtValue = new BDYWeightValueBean();
            wtValue.setMeasDate(getRequest().getParameter("txtMeasDate"));
            wtValue.setWeight(COMUtility.getDoubleParam(getRequest().getParameter("txtWeight")));
            wtValue.setBMI(COMUtility.getDoubleParam(getRequest().getParameter("txtBMI")));
            wtValue.setBodyFat(COMUtility.getDoubleParam(getRequest().getParameter("txtBodyFat")));
            wtValue.setBodyFat(COMUtility.getDoubleParam(getRequest().getParameter("txtVisceralFat")));
            wtValue.setBodyFat(COMUtility.getDoubleParam(getRequest().getParameter("txtMuscleMass")));
            wtValue.setBodyFat(COMUtility.getDoubleParam(getRequest().getParameter("txtBasalMetabolism")));

            value.getWeightValueList().add(wtValue);
            control.setTargetValue(value);

            if (!control.insert()) {
                return false;
            }
        }
        catch (InstantiationException e) {
            e.printStackTrace();
            return false;
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
}
