package controllers.ext.rst;

import java.util.List;

import util.com.COMDef;

import com.taskadapter.redmineapi.IssueManager;
import com.taskadapter.redmineapi.RedmineException;
import com.taskadapter.redmineapi.RedmineManager;
import com.taskadapter.redmineapi.RedmineManagerFactory;
import com.taskadapter.redmineapi.bean.Issue;

import controllers.ueat.com.COMRequestManager;
import controllers.ueat.exp.EXPCommonManager;
import controllers.ueat.exp.EXPManagerInterface;

public class RSTServiceManager
    extends EXPCommonManager implements EXPManagerInterface {

    @Override
    public boolean execute() {
        String requestName = getRequest().getParameter("request");
        String queryPattern = COMRequestManager.getInstance().getQueryPattern(requestName);

        switch (requestName) {
        case "execRedmineRest":

            switch (queryPattern) {
            case COMDef.QUERY_PTN_SELECT:
                if (!execRedmineRest()) {
                    return false;
                }
                break;
            }

            break;
        }

        return true;
    }

    public boolean execRedmineRest() {
        String uri = "http://10.180.204.206";
        String apiAccessKey = "caebbc2d8330802b037a1990e1996f5aa9964e35";
        String projectKey = "test";
        Integer queryId = null;
        try {
            RedmineManager mgr = RedmineManagerFactory.createWithApiKey(uri, apiAccessKey);

            IssueManager issueManager = mgr.getIssueManager();
            List<Issue> issues;
                issues = issueManager.getIssues(projectKey, queryId);

            for (Issue issue : issues) {
             System.out.println(issue.toString());
             System.out.println("Description :      " + issue.getDescription());
             System.out.println("StartDate :        " + issue.getStartDate().toString());
             System.out.println("DueDate :          " +  issue.getDueDate().toString());
             System.out.println("EstimatedHours :   " + issue.getEstimatedHours());
            }
        }
        catch (RedmineException e) {
            e.printStackTrace();
        }

        return true;
    }
}

