package controllers.ext.sal;

import models.ext.sal.SALPayHistoryValueBean;
import models.ext.sal.SALPayStatementValueBean;
import controllers.ueat.com.COMChartMaterialImpl;

public class SALStructHighChartData extends COMChartMaterialImpl {

    private SALPayHistoryValueBean TargetValue;

    public String createPayChartData() {

        StringBuffer sbChartdef = new StringBuffer();
        sbChartdef.append("{");

        // **************************************************************
        // property basic property
        // --------------------------------------------------------------
        sbChartdef.append(createBasicProperty());

        // **************************************************************
        sbChartdef.append("}");

        return sbChartdef.toString();
    }

    @Override
    public Object getTargetValue() {
        return (SALPayHistoryValueBean)TargetValue;
    }

    @Override
    public void setTargetValue(Object prevValue) {
        TargetValue = (SALPayHistoryValueBean)prevValue;
    }

    @Override
    public String createPropXAxis() {
        String xCatego = "";
        SALPayHistoryValueBean value = (SALPayHistoryValueBean)getTargetValue();

        StringBuffer sbXCategory = new StringBuffer();
        for (int i = 0; i < value.getPayStatementList().size(); i++) {
            SALPayStatementValueBean psValue = (SALPayStatementValueBean)value.getPayStatementList().get(i);
            sbXCategory.append("'").append(psValue.getPayDate()).append("',");
        }
        xCatego = sbXCategory.toString();
        xCatego = xCatego.substring(0, xCatego.length() - 1);

        return String.format(HC_PROP_X_AXIS, xCatego);
    }

    @Override
    public String createPropSeriesData() {
        SALPayHistoryValueBean value = (SALPayHistoryValueBean)getTargetValue();

        StringBuffer sbTotalAmount = new StringBuffer();
        StringBuffer sbDeduct = new StringBuffer();
        StringBuffer sbNetAmount = new StringBuffer();

        for (int i = 0; i < value.getPayStatementList().size(); i++) {
            SALPayStatementValueBean psValue = (SALPayStatementValueBean)value.getPayStatementList().get(i);
            sbTotalAmount.append(psValue.getTotalAmountPaid()).append(",");
            sbDeduct.append(psValue.getDeductTotal()).append(",");
            sbNetAmount.append(psValue.getNetAmountPaid()).append(",");
        }

        String total = sbTotalAmount.toString();
        String deduct = sbDeduct.toString();
        String net = sbNetAmount.toString();
        total = total.substring(0, total.length() - 1);
        deduct = deduct.substring(0, deduct.length() - 1);
        net = net.substring(0, net.length() - 1);

        StringBuffer sbSeries = new StringBuffer();
        sbSeries.append("{");
        sbSeries.append(HC_PROP_NAME).append(": ").append("'Total Amount Paid'").append(", ");
        sbSeries.append(HC_PROP_DATA).append(": [").append(total).append("]");
        sbSeries.append("}").append(", ");
        sbSeries.append("{");
        sbSeries.append(HC_PROP_NAME).append(": ").append("'Deduct'").append(", ");
        sbSeries.append(HC_PROP_DATA).append(": [").append(deduct).append("]");
        sbSeries.append("}").append(", ");
        sbSeries.append("{");
        sbSeries.append(HC_PROP_NAME).append(": ").append("'Net Amount Paid'").append(", ");
        sbSeries.append(HC_PROP_DATA).append(": [").append(net).append("]");
        sbSeries.append("}");

        return String.format(HC_PROP_SERIES, sbSeries.toString());
    }
}
