package controllers.ueat.com;

import models.ueat.exp.EXPHighChartValueBean;

public class COMChartMaterialImpl implements COMChartMaterialInterface {

    protected static final String HC_PROP_CHART = "chart: {width: %d, height: %d}";
    protected static final String HC_PROP_TITLE = "title: {text: '%s', x: %d}";
    protected static final String HC_PROP_SUBTITLE = "subtitle: {text: '%s', x: %d}";
    protected static final String HC_PROP_X_AXIS = "xAxis: {categories: [ %s ] }";
    protected static final String HC_PROP_Y_AXIS = "yAxis: {"
                                                + "title: {text: '%s'},"
                                                + "plotLines: [ {value: %d, width: %d, color: '%s'} ]"
                                                + "}";
    protected static final String HC_PROP_TOOLTIP = "tooltip: {valueSuffix: '%s'}";
    protected static final String HC_PROP_LEGEND = "legend: {"
                                                + "layout: '%s',"
                                                + "align: '%s',"
                                                + "verticalAlign: '%s',"
                                                + "borderWidth: %d"
                                                + "}";
    protected static final String HC_PROP_SERIES = "series: [ %s ]";
    protected static final String HC_PROP_NAME = "name";
    protected static final String HC_PROP_DATA = "data";

    private EXPHighChartValueBean HighChartValue;

    public EXPHighChartValueBean getHighChartValue() {
        return HighChartValue;
    }

    public void setHighChartValue(EXPHighChartValueBean highChartValue) {
        HighChartValue = highChartValue;
    }

    public String createBasicProperty() {
        StringBuffer sbChartdef = new StringBuffer();
        // **************************************************************
        // property chart
        // --------------------------------------------------------------
        sbChartdef.append(createPropChart());
        sbChartdef.append(",");
        // **************************************************************
        // property title
        // --------------------------------------------------------------
        sbChartdef.append(createPropTitle());
        sbChartdef.append(",");
        sbChartdef.append(createPropSubtitle());
        sbChartdef.append(",");
        // **************************************************************
        // property xAxis
        // --------------------------------------------------------------
        sbChartdef.append(createPropXAxis());
        sbChartdef.append(",");
        // **************************************************************
        // property yAxis
        // --------------------------------------------------------------
        sbChartdef.append(createPropYAxis());
        sbChartdef.append(",");
        // **************************************************************
        // property tooltip
        // --------------------------------------------------------------
        sbChartdef.append(createPropTooltip());
        sbChartdef.append(",");
        // **************************************************************
        // property legend
        // --------------------------------------------------------------
        sbChartdef.append(createPropLegend());
        sbChartdef.append(",");
        // **************************************************************
        // property series
        // --------------------------------------------------------------
        sbChartdef.append(createPropSeriesData());

        return sbChartdef.toString();
    }

    @Override
    public String createPropChart() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_CHART, HighChartValue.getDispWidth(), HighChartValue.getDispHeight());
        } else {
            return "";
        }
    }

    @Override
    public String createPropTitle() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_TITLE, HighChartValue.getTitleText(), HighChartValue.getTitleX());
        } else {
            return "";
        }
    }

    @Override
    public String createPropSubtitle() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_SUBTITLE, HighChartValue.getSubTitleText(), HighChartValue.getSubTitleX());
        } else {
            return "";
        }
    }

    @Override
    public String createPropXAxis() {
        return null;
    }

    @Override
    public String createPropYAxis() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_Y_AXIS,
                    HighChartValue.getYAxisTitle(),
                    HighChartValue.getPlotLineValue(),
                    HighChartValue.getPlotLineWidth(),
                    HighChartValue.getPlotLineColor()
                    );
        } else {
            return "";
        }
    }

    @Override
    public String createPropTooltip() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_TOOLTIP, HighChartValue.getToolTip());
        } else {
            return "";
        }
    }

    @Override
    public String createPropLegend() {
        if (HighChartValue != null) {
            return String.format(HC_PROP_LEGEND,
                    HighChartValue.getLegendLayout(),
                    HighChartValue.getLegendAlign(),
                    HighChartValue.getLegendVerticalAlign(),
                    HighChartValue.getLegendBorderWidth()
                    );
        } else {
            return "";
        }
    }

    @Override
    public String createPropSeriesData() {
        return null;
    }

    @Override
    public Object getTargetValue() {
        return null;
    }

    @Override
    public void setTargetValue(Object prevValue) {
    }

}
