package controllers.ueat.com;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletContext;

import models.ueat.com.COMRequestDefValue;

import org.dom4j.DocumentException;

import util.com.COMRequestDefReader;

public class COMRequestManager {

    private static COMRequestManager Instance;
    private ServletContext ServletContext;
    private String XmlDefPath;
    private List ReqDef;

    public static COMRequestManager getInstance() {
        if (Instance == null) {
            Instance = new COMRequestManager();
        }
        return Instance;
    }

    public void initialize(ServletContext servletContext) {
        getInstance().ServletContext = servletContext;

        try {
            COMRequestDefReader defReader = new COMRequestDefReader();
            ReqDef = new ArrayList<COMRequestDefValue>();

            File file = new File(servletContext.getRealPath("/def/RequestDef.xml"));
            if (file.exists()) {
                List reqDefValue = new ArrayList<COMRequestDefValue>();
                defReader.readRequestDef(file.getPath(), ReqDef);
            }
        }
        catch (DocumentException e) {
            e.printStackTrace();
        }
    }

    public ServletContext getServletContext() {
        return getInstance().ServletContext;
    }

    public COMRequestDefValue getRequestDef(String reqName) {
        for (int i = 0; i < ReqDef.size(); i++) {
            if (reqName.equals(((COMRequestDefValue)ReqDef.get(i)).getRequestName())) {
                return ((COMRequestDefValue)ReqDef.get(i));
            }
        }
        return null;
    }

    public String getManagerName(String reqName) {
        return getRequestDef(reqName).getManager();
    }

    public String getPackageName(String reqName) {
        return getRequestDef(reqName).getPackage();
    }

    public String getNextPage(String reqName) {
        return getRequestDef(reqName).getNextPage();
    }

    public String getQueryPattern(String reqName) {
        return getRequestDef(reqName).getQueryPattern();
    }
}
