package controllers.ueat.exp;

import models.ueat.dba.DBAControlBeanInterface;
import models.ueat.dba.DBAGasBillControlBean;
import models.ueat.exp.EXPConditionValueBean;
import models.ueat.exp.EXPGasBillBValueBean;
import models.ueat.exp.EXPHighChartValueBean;
import models.ueat.exp.EXPUtilityExpensesValueBean;
import util.com.COMDef;
import controllers.ueat.com.COMRequestManager;


public class EXPGasBillManager
    extends EXPCommonManager implements EXPManagerInterface {

    @Override
    public boolean execute() {
        String requestName = getRequest().getParameter("request");
        String queryPattern = COMRequestManager.getInstance().getQueryPattern(requestName);
        switch (queryPattern) {
        case COMDef.QUERY_PTN_SELECT:
            if (!draw()) {
                return false;
            }
            break;
        case COMDef.QUERY_PTN_INSERT:
            if (!addData()) {
                return false;
            }
            break;
        case COMDef.QUERY_PTN_UPDATE:
            break;
        case COMDef.QUERY_PTN_DELETE:
            break;
        default:
            break;
        }

        return true;
    }

    private boolean draw() {
        try {
            DBAControlBeanInterface control = DBAGasBillControlBean.class.newInstance();

            EXPConditionValueBean condValue = new EXPConditionValueBean();
//          condValue.setTargetID(10);
//            condValue.setWhereCond("used_date between '2008-01-01' and '2010-01-01'");
            control.setCondParam(condValue);
            if (!control.select()) {
                return false;
            }

            EXPStructHighChartData chData = new EXPStructHighChartData();
            EXPHighChartValueBean hcValue = new EXPHighChartValueBean();
            hcValue.setDispHeight(600);
            hcValue.setDispWidth(1000);
            chData.setHighChartValue(hcValue);
            chData.setTargetValue((EXPUtilityExpensesValueBean)control.getResultValue());
            String strChartData = chData.createBillChartData();
            ((EXPUtilityExpensesValueBean)control.getResultValue()).setHighChartData(strChartData);

            setValueBean(control.getResultValue());
        }
        catch (InstantiationException e) {
            e.printStackTrace();
            return false;
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
            return false;
        }

        return true;
    }

    private boolean addData() {
        DBAControlBeanInterface control;
        try {
            control = DBAGasBillControlBean.class.newInstance();

            EXPUtilityExpensesValueBean value = new EXPUtilityExpensesValueBean();

            EXPGasBillBValueBean ebValue = new EXPGasBillBValueBean();
            ebValue.setLoginUserID("fuji0");
            ebValue.setUsedDate(getRequest().getParameter("txtGbUsedDate"));
            ebValue.setGasUsage(Double.parseDouble(getRequest().getParameter("txtGbUsage")));
            ebValue.setBasicCharge(Double.parseDouble(getRequest().getParameter("txtGbBasicCharge")));
            ebValue.setEnergyCharge(Double.parseDouble(getRequest().getParameter("txtGbEnergyCharge")));
            ebValue.setPayment(Double.parseDouble(getRequest().getParameter("txtGbPayment")));

            value.getExpGBValueBeanList().add(ebValue);
            control.setTargetValue(value);

            if (!control.insert()) {
                return false;
            }
        }
        catch (InstantiationException e) {
            e.printStackTrace();
            return false;
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
}
