package controllers.ueat.exp;

import models.ueat.exp.EXPElectricityBillBValueBean;
import models.ueat.exp.EXPGasBillBValueBean;
import models.ueat.exp.EXPUtilityExpensesValueBean;
import models.ueat.exp.EXPWaterBillBValueBean;
import util.exp.EXPDef;
import controllers.ueat.com.COMChartMaterialImpl;

public class EXPStructHighChartData extends COMChartMaterialImpl {

    private EXPUtilityExpensesValueBean TargetValue;

    public String createBillChartData() {

        StringBuffer sbChartdef = new StringBuffer();
        sbChartdef.append("{");

        // **************************************************************
        // property basic property
        // --------------------------------------------------------------
        sbChartdef.append(createBasicProperty());

        // **************************************************************
        sbChartdef.append("}");

        return sbChartdef.toString();
    }

    @Override
    public Object getTargetValue() {
        return (EXPUtilityExpensesValueBean)TargetValue;
    }

    @Override
    public void setTargetValue(Object prevValue) {
        TargetValue = (EXPUtilityExpensesValueBean)prevValue;
    }

    @Override
    public String createPropXAxis() {
        String xCatego = "";
        EXPUtilityExpensesValueBean value = (EXPUtilityExpensesValueBean)getTargetValue();

        StringBuffer sbXCategory = new StringBuffer();
        if (value.getExpKind().equals(EXPDef.ExpKind.Electricity)) {
            for (int i = 0; i < value.getExpEBValueBeanList().size(); i++) {
                EXPElectricityBillBValueBean ebValue = (EXPElectricityBillBValueBean)value.getExpEBValueBeanList().get(i);
                sbXCategory.append("'").append(ebValue.getUsedDate()).append("',");
            }
        } else if (value.getExpKind().equals(EXPDef.ExpKind.Gas)) {
            for (int i = 0; i < value.getExpGBValueBeanList().size(); i++) {
                EXPGasBillBValueBean gbValue = (EXPGasBillBValueBean)value.getExpGBValueBeanList().get(i);
                sbXCategory.append("'").append(gbValue.getUsedDate()).append("',");
            }
        } else if (value.getExpKind().equals(EXPDef.ExpKind.Water)) {
            for (int i = 0; i < value.getExpWBValueBeanList().size(); i++) {
                EXPWaterBillBValueBean wbValue = (EXPWaterBillBValueBean)value.getExpWBValueBeanList().get(i);
                sbXCategory.append("'").append(wbValue.getUsedDate()).append("',");
            }
        }
        xCatego = sbXCategory.toString();
        xCatego = xCatego.substring(0, xCatego.length() - 1);

        return String.format(HC_PROP_X_AXIS, xCatego);
    }

    @Override
    public String createPropSeriesData() {
        EXPUtilityExpensesValueBean value = (EXPUtilityExpensesValueBean)getTargetValue();

        StringBuffer sbUsage = new StringBuffer();
        StringBuffer sbPayment = new StringBuffer();

        if (value.getExpKind().equals(EXPDef.ExpKind.Electricity)) {
            for (int i = 0; i < value.getExpEBValueBeanList().size(); i++) {
                EXPElectricityBillBValueBean ebValue = (EXPElectricityBillBValueBean)value.getExpEBValueBeanList().get(i);
                sbUsage.append(ebValue.getElectricityUsage()).append(",");
                sbPayment.append(ebValue.getPayment()).append(",");
            }
        } else if (value.getExpKind().equals(EXPDef.ExpKind.Gas)) {
            for (int i = 0; i < value.getExpGBValueBeanList().size(); i++) {
                EXPGasBillBValueBean gbValue = (EXPGasBillBValueBean)value.getExpGBValueBeanList().get(i);
                sbUsage.append(gbValue.getGasUsage()).append(",");
                sbPayment.append(gbValue.getPayment()).append(",");
            }
        } else if (value.getExpKind().equals(EXPDef.ExpKind.Water)) {
            for (int i = 0; i < value.getExpWBValueBeanList().size(); i++) {
                EXPWaterBillBValueBean wbValue = (EXPWaterBillBValueBean)value.getExpWBValueBeanList().get(i);
                sbUsage.append(wbValue.getWaterUsage()).append(",");
                sbPayment.append(wbValue.getPayment()).append(",");
            }
        }

        String usage = sbUsage.toString();
        String payment = sbPayment.toString();
        usage = usage.substring(0, usage.length() - 1);
        payment = payment.substring(0, payment.length() - 1);

        StringBuffer sbSeries = new StringBuffer();
        sbSeries.append("{");
        sbSeries.append(HC_PROP_NAME).append(": ").append("'Usage'").append(", ");
        sbSeries.append(HC_PROP_DATA).append(": [").append(usage).append("]");
        sbSeries.append("}").append(", ");
        sbSeries.append("{");
        sbSeries.append(HC_PROP_NAME).append(": ").append("'Payment'").append(", ");
        sbSeries.append(HC_PROP_DATA).append(": [").append(payment).append("]");
        sbSeries.append("}");

        return String.format(HC_PROP_SERIES, sbSeries.toString());
    }
}
