package models.ext.dba.sal;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import models.ext.sal.SALDesignInfoValueBean;
import models.ueat.dba.DBACommonControlBean;
import models.ueat.dba.DBAControlBeanInterface;
import models.ueat.exp.EXPConditionValueBean;
import util.com.COMUtility;

public class DBAPsDesignInfoControlBean
    extends DBACommonControlBean implements DBAControlBeanInterface {

    private static String DBTBL_NAME = "ps_design_info";

    private EXPConditionValueBean CondValue;
    private SALDesignInfoValueBean TargetValue;
    private SALDesignInfoValueBean ResultValue;

    @Override
    public Object getCondParam() {
        if (CondValue == null) {
            return null;
        } else {
            return (EXPConditionValueBean)CondValue;
        }
    }

    @Override
    public void setCondParam(Object cond) {
        CondValue = null;
        if (cond != null) {
            CondValue = (EXPConditionValueBean)cond;
        }
    }

    @Override
    public Object getTargetValue() {
        if (TargetValue == null) {
            return null;
        } else {
            return (SALDesignInfoValueBean)TargetValue;
        }
    }

    @Override
    public void setTargetValue(Object prevValue) {
        TargetValue = null;
        if (prevValue != null) {
            TargetValue = (SALDesignInfoValueBean)prevValue;
        }
    }

    @Override
    public Object getResultValue() {
        if (ResultValue == null) {
            return null;
        } else {
            return (SALDesignInfoValueBean)ResultValue;
        }
    }

    @Override
    public void setResultValue(Object nextValue) {
        ResultValue = null;
        if (nextValue != null) {
            ResultValue = (SALDesignInfoValueBean)nextValue;
        }
    }

    @Override
    public boolean select() {

        try {
            Connection conn = getConnection();

            StringBuffer sql = new StringBuffer();
            sql.append("SELECT ");
            sql.append("    * ");
            sql.append("FROM ");
            sql.append("    " + DBTBL_NAME);

            String cond = createWhereSql((EXPConditionValueBean)getCondParam());
            if (!COMUtility.isNullOrEmpty(cond)) {
                sql.append(cond);
            }

            PreparedStatement prepStmt = conn.prepareStatement(sql.toString());
            ResultSet rs = prepStmt.executeQuery();

            SALDesignInfoValueBean nextValue = new SALDesignInfoValueBean();
            while (rs.next()) {
                SALDesignInfoValueBean.DesignElement dsElem = nextValue.new DesignElement();
                dsElem.setID(rs.getInt("id"));
                dsElem.setCategory(rs.getString("category"));
                dsElem.setCaption_ENG(rs.getString("caption_eng"));
                dsElem.setCaption_JP(rs.getString("caption_jp"));
                dsElem.setReqPrmName(rs.getString("request_param_name"));
                if("TRUE".equals(rs.getString("is_disabled").toUpperCase())) {
                    dsElem.setDisabled(true);
                } else {
                    dsElem.setDisabled(false);
                }
                if("TRUE".equals(rs.getString("pay_enabled").toUpperCase())) {
                    dsElem.setPayEnabled(true);
                } else {
                    dsElem.setPayEnabled(false);
                }
                if("TRUE".equals(rs.getString("bonus_enabled").toUpperCase())) {
                    dsElem.setBonusEnabled(true);
                } else {
                    dsElem.setBonusEnabled(false);
                }
                dsElem.setDBTableName(rs.getString("db_table_name"));
                dsElem.setDBColName(rs.getString("db_col_name"));
                dsElem.setClassName(rs.getString("class"));
                dsElem.setComment(rs.getString("comment"));
                nextValue.getDesignList().add(dsElem);
            }
            conn.close();

            setResultValue(nextValue);
        }
        catch (SQLException e) {
            return false;
        }

        return true;
    }

    @Override
    public boolean insert() {
        return true;
    }

    @Override
    public boolean update() {
        // TODO 自動生成されたメソッド・スタブ
        return false;
    }

    @Override
    public boolean delete() {
        // TODO 自動生成されたメソッド・スタブ
        return false;
    }
}
