package models.ueat.dba;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import models.ueat.exp.EXPConditionValueBean;
import util.com.COMUtility;

public class DBACommonControlBean {

    private Connection ConnectionObject;
    private int ResultCount;
    private String OccuredTime;

    protected Connection getConnection() {
        ConnectionObject = null;

        try {
            Context context = new InitialContext();
            DataSource ds = (DataSource)context.lookup("java:comp/env/jdbc/ueat");
            ConnectionObject = ds.getConnection();
        } catch (NamingException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return ConnectionObject;
    }

    public void setKeepConnection(Connection conn) {
        ConnectionObject = conn;
    }

    public Connection getKeepConnection() {
        return ConnectionObject;
    }
    public Connection getConnectionObject() {
        return ConnectionObject;
    }

    public void setConnectionObject(Connection connectionObject) {
        ConnectionObject = connectionObject;
    }

    public String getOccuredTime() {
        return OccuredTime;
    }
    public void setOccuredTime(String occuredTime) {
        OccuredTime = occuredTime;
    }

    protected String createWhereSql(EXPConditionValueBean condValue) {

        if (condValue == null) {
            return "";
        }
        StringBuffer sb = new StringBuffer();

        String where = " where ";
        boolean isWhere = false;

        if (condValue.getTargetID() > 0) {
            sb.append(where);
            isWhere = true;
            sb.append(" id = ").append(condValue.getTargetID());
        }
        if (!COMUtility.isNullOrEmpty(condValue.getWhereCond())) {
            if (!isWhere) {
                sb.append(where);
            } else {
                sb.append(" and ");
            }
            sb.append(condValue.getWhereCond());
        }

        return sb.toString();
    }

    protected int issueNewId(String targetTable) throws SQLException {
        int id = 0;

        Connection conn = getConnection();

        StringBuffer sql = new StringBuffer();
        sql.append("SELECT ");
        sql.append("    max(id) as last_id ");
        sql.append("FROM ");
        sql.append("    " + targetTable);

        PreparedStatement prepStmt = conn.prepareStatement(sql.toString());
        ResultSet rs = prepStmt.executeQuery();
        while (rs.next()) {
            id = rs.getInt("last_id");
        }
        conn.close();

        return (id + 1);
    }

    public int getResultCount() {
        return ResultCount;
    }

    public void setResultCount(int resultCount) {
        ResultCount = resultCount;
    }

}
