package util.com;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.net.URL;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

public class COMDataDump {
    private List theCategoryList = null;

    public COMDataDump() {

    }

    public void dumpData(Object testValue, Field field)
            throws ArrayIndexOutOfBoundsException, IllegalArgumentException, IllegalAccessException {
        if(!Modifier.isPublic(field.getModifiers())) {
            field.setAccessible(true);
        }
        if(field.getType().isArray()) {
            StringBuffer strBuf = new StringBuffer();
            strBuf.append("Field: " + field.getName() + ", value: [");
            for(int i=0; i < Array.getLength(field.get(testValue)); i++) {
                strBuf.append(Array.get(field.get(testValue), i) + ", ");
            }
            strBuf.append("] ");
            System.out.println(strBuf);
        }
        else if(field.getType().toString().equals("interface java.util.List")) {
            java.util.List list = (java.util.List)field.get(testValue);
            StringBuffer strBuf = new StringBuffer();
            strBuf.append("Field: " + field.getName() + ", value: [");

            if(list != null && list.size() > 0) {
                for(Iterator i = list.iterator(); i.hasNext();) {
                    Object nextObj = i.next();
                    if(nextObj == null) {
                        strBuf.append("null, ");
                    }
                    else if(existTargetCategory2(nextObj)) {
                        Field fields_curr[] = nextObj.getClass().getDeclaredFields();
                        Field fields_super[] = nextObj.getClass().getSuperclass().getDeclaredFields();
                        Field fields_sub[] = new Field[fields_curr.length + fields_super.length];
                        System.arraycopy(fields_curr, 0, fields_sub, 0, fields_curr.length);
                        System.arraycopy(fields_super, 0, fields_sub, fields_curr.length, fields_super.length);
                        Arrays.sort(fields_sub, new FieldComparator());
                        dumpData(nextObj, fields_sub);
                    }
                    else {
                        strBuf.append(nextObj + ", ");
                    }
                }
            }
            else {
                strBuf.append("null");
            }
             strBuf.append("] ");
            System.out.println(strBuf);
        }
        else if(field.getType().toString().equals("class java.util.HashMap")) {
            java.util.HashMap hashMap = (java.util.HashMap)field.get(testValue);
            StringBuffer strBuf = new StringBuffer();
            strBuf.append("Field: " + field.getName() + ", value: [");

            if(hashMap != null && hashMap.size() > 0) {
                for(Iterator<Object> i = hashMap.keySet().iterator(); i.hasNext(); ) {
                    Object nextObj = i.next();
                    System.out.println("HashMap - start : " + field.getName() + " key=" + nextObj.toString() + "*************************************");
                    if(hashMap.get(nextObj) == null) {
                        strBuf.append("null, ");
                    }
                    else if(existTargetCategory2(hashMap.get(nextObj))) {
                        Field fields_curr[] = hashMap.get(nextObj).getClass().getDeclaredFields();
                        Field fields_super[] = hashMap.get(nextObj).getClass().getSuperclass().getDeclaredFields();
                        Field fields_sub[] = new Field[fields_curr.length + fields_super.length];
                        System.arraycopy(fields_curr, 0, fields_sub, 0, fields_curr.length);
                        System.arraycopy(fields_super, 0, fields_sub, fields_curr.length, fields_super.length);
                        Arrays.sort(fields_sub, new FieldComparator());
                        dumpData(hashMap.get(nextObj), fields_sub);
                    }
                    else {
                        strBuf.append(hashMap.get(nextObj) + ", ");
                    }
                    System.out.println("HashMap - end : " + field.getName() + " key=" + nextObj.toString() + "*************************************");
                }
            }
            else {
                strBuf.append("null");
            }
             strBuf.append("] ");
            System.out.println(strBuf);
        }
        else if(field.get(testValue) != null && existTargetCategory(field, testValue)) {
            System.out.println("Sub Container - start : " + field.getType().toString() + "*************************************");
            Field fields_sub[] = field.getType().getDeclaredFields();
            Object sub_obj = field.get(testValue);
            dumpData(sub_obj, fields_sub);
            System.out.println("Sub Container - end : " + field.getType().toString() + "*************************************");
        }
        else {
            System.out.println("Field: " + field.getName() + ", value: " + field.get(testValue));
        }
    }

    public void dumpData(Object testValue, Field[] fields) {
        try {
            for(Field field : fields) {
                dumpData(testValue, field);
            }
        }
        catch (IllegalArgumentException e) {
            e.printStackTrace();
        }
        catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setTargetCategory(List categoryList) {
        theCategoryList = categoryList;
    }

    private boolean existTargetCategory(Field field, Object value) {
        boolean retVal = false;
        if(theCategoryList != null) {
            for (int i = 0; i < theCategoryList.size(); i++) {
                try {
                    if(field.get(value).toString().startsWith((String)theCategoryList.get(i))) {
                        retVal = true;
                        break;
                    }
                }
                catch (IllegalArgumentException e) {
                    e.printStackTrace();
                }
                catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
        }
        return retVal;
    }

    private boolean existTargetCategory2(Object value) {
        boolean retVal = false;
        if(theCategoryList != null) {
            for (int i = 0; i < theCategoryList.size(); i++) {
                try {
                    if(value.toString().startsWith((String)theCategoryList.get(i))) {
                        retVal = true;
                        break;
                    }
                }
                catch (IllegalArgumentException e) {
                    e.printStackTrace();
                }
            }
        }
        return retVal;
    }

    public class FieldComparator implements Comparator<Object>
    {
        public int compare(Object object1, Object object2) {
            Field field1 = (Field)object1;
            Field field2 = (Field)object2;
            int i = field1.getName().compareTo(field2.getName());
            if(i < 0) {
                return -1;
            }
            else if(i > 0) {
                return 1;
            }
            else {
                return 0;
            }
        }
    }

    public void setTargetCategoryFromPackage(List packageList)
            throws ClassNotFoundException, IOException {
        theCategoryList = new ArrayList<String>();
        for (int i = 0; i < packageList.size(); i++) {
            List<Class> classList = getClasses(packageList.get(i).toString());
            for (int j = 0; j < classList.size(); j++) {
                theCategoryList.add(classList.get(j).getName());
            }
        }

    }

    /**
     * Scans all classes accessible from the context class loader which belong
     * to the given package and subpackages.
     *
     * @param packageName
     *            The base package
     * @return The classes
     * @throws ClassNotFoundException
     * @throws IOException
     */
    @SuppressWarnings("rawtypes")
    private static List<Class> getClasses(String packageName)
            throws ClassNotFoundException, IOException {
        ClassLoader classLoader = Thread.currentThread()
                .getContextClassLoader();
        assert classLoader != null;
        String path = packageName.replace('.', '/');
        Enumeration<URL> resources = classLoader.getResources(path);
        List<File> dirs = new ArrayList<File>();
        while (resources.hasMoreElements()) {
            URL resource = resources.nextElement();
            String fileName = resource.getFile();
            String fileNameDecoded = URLDecoder.decode(fileName, "UTF-8");
            dirs.add(new File(fileNameDecoded));
        }
        ArrayList<Class> classes = new ArrayList<Class>();
        for (File directory : dirs) {
            classes.addAll(findClasses(directory, packageName));
        }
        return classes;
    }

    /**
     * Recursive method used to find all classes in a given directory and
     * subdirs.
     *
     * @param directory
     *            The base directory
     * @param packageName
     *            The package name for classes found inside the base directory
     * @return The classes
     * @throws ClassNotFoundException
     */
    @SuppressWarnings("rawtypes")
    private static List<Class> findClasses(File directory, String packageName)
            throws ClassNotFoundException {
        List<Class> classes = new ArrayList<Class>();
        if (!directory.exists()) {
            return classes;
        }
        File[] files = directory.listFiles();
        for (File file : files) {
            String fileName = file.getName();
            if (file.isDirectory()) {
                assert !fileName.contains(".");
                classes.addAll(findClasses(file, packageName + "." + fileName));
            } else if (fileName.endsWith(".class") && !fileName.contains("$")) {
                Class _class;
                try {
                    _class = Class.forName(packageName + '.'
                            + fileName.substring(0, fileName.length() - 6));
                } catch (ExceptionInInitializerError e) {
                    // happen, for example, in classes, which depend on
                    // Spring to inject some beans, and which fail,
                    // if dependency is not fulfilled
                    _class = Class.forName(
                            packageName
                                    + '.'
                                    + fileName.substring(0,
                                            fileName.length() - 6), false,
                            Thread.currentThread().getContextClassLoader());
                }
                classes.add(_class);
            }
        }
        return classes;
    }
}
