package util.com;

import java.util.Iterator;
import java.util.List;

import models.ueat.com.COMRequestDefValue;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

public class COMRequestDefReader {

    public static final String XML_TAG_REQUEST = "Request";
    public static final String XML_TAG_PACKAGE = "Package";
    public static final String XML_TAG_MANAGER = "Manager";
    public static final String XML_TAG_QUERY = "Query";
    public static final String XML_TAG_NEXTPAGE = "NextPage";

    public static final String XML_ATTR_NAME = "name";
    public static final String XML_ATTR_CLASS = "class";
    public static final String XML_ATTR_PATTERN = "pattern";
    public static final String XML_ATTR_PATH = "path";

    public void readRequestDef(String defPath, List<COMRequestDefValue> list)
            throws DocumentException {

        SAXReader reader = new SAXReader();
        Document document = reader.read(defPath);
        Element root = document.getRootElement();

        for (Iterator ite = root.elementIterator(); ite.hasNext();) {
            Element element = (Element)ite.next();
            for (Iterator iteChild = element.elementIterator(); iteChild.hasNext();) {
                Element reqNode = (Element)iteChild.next();
                if (XML_TAG_REQUEST.equals(reqNode.getName())) {
                    COMRequestDefValue value = new COMRequestDefValue();
                    getRequestNode(reqNode, value);
                    list.add(value);
                }
            }
        }
    }

    private void getRequestNode(Element reqNode, COMRequestDefValue value) {
        value.setRequestName(reqNode.attributeValue(XML_ATTR_NAME));
        for (Iterator ite = reqNode.elementIterator(); ite.hasNext();) {
            Element childNode = (Element)ite.next();
            if (XML_TAG_MANAGER.equals(childNode.getName())) {
                value.setManager(childNode.attributeValue(XML_ATTR_CLASS));
            } else if (XML_TAG_PACKAGE.equals(childNode.getName())) {
                value.setPackage(childNode.attributeValue(XML_ATTR_NAME));
            } else if (XML_TAG_QUERY.equals(childNode.getName())) {
                value.setQueryPattern(childNode.attributeValue(XML_ATTR_PATTERN));
            } else if (XML_TAG_NEXTPAGE.equals(childNode.getName())) {
                value.setNextPage(childNode.attributeValue(XML_ATTR_PATH));
            }
        }
    }
}
