SET SESSION FOREIGN_KEY_CHECKS=0;

/* Drop Tables */

DROP TABLE IF EXISTS electricity_bill;
DROP TABLE IF EXISTS gas_bill;
DROP TABLE IF EXISTS water_bill;




/* Create Tables */

-- 電気代 : usage - unit : kWh
CREATE TABLE electricity_bill
(
	id int NOT NULL AUTO_INCREMENT COMMENT 'id',
	user_id varchar(30) NOT NULL COMMENT '使用者ID',
	used_date date NOT NULL COMMENT '使用日',
	electricity_usage decimal(10,4) COMMENT '電気使用量',
	payment decimal(10,4) COMMENT '支払金額',
	PRIMARY KEY (id)
) COMMENT = '電気代 : usage - unit : kWh';


-- ガス代 : usage - unit : m2
CREATE TABLE gas_bill
(
	id int NOT NULL AUTO_INCREMENT COMMENT 'id',
	user_id varchar(30) COMMENT '使用者ID',
	used_date date NOT NULL COMMENT '使用日',
	gas_usage decimal(10,4) COMMENT 'ガス使用量',
	basic_charge decimal(10,4) COMMENT '基本料金',
	energy_charge decimal(10,4) COMMENT '従量料金',
	payment decimal(10,4) COMMENT '支払金額',
	PRIMARY KEY (id)
) COMMENT = 'ガス代 : usage - unit : m2';


-- 水道代 : usage - unit : m2
CREATE TABLE water_bill
(
	id int NOT NULL AUTO_INCREMENT COMMENT 'id',
	user_id varchar(30) COMMENT '使用者ID',
	used_date date NOT NULL COMMENT '使用日',
	water_usage decimal(10,4) COMMENT '水道使用量',
	payment decimal(10,4) COMMENT '支払金額',
	PRIMARY KEY (id)
) COMMENT = '水道代 : usage - unit : m2';



